# Execute a batch request

> Source: https://truto.one/docs/api-reference/admin/batch-requests/create/

`POST /batch-request`

Resource: **Batch Requests**

## Request body

- **`integrated_account_id`** _(string)_
  The ID of the integrated account in whose context these resource calls are made.
- **`args`** _(object)_
  Optional arguments available for placeholder replacement in resource definitions.
- **`resources`** _(array<object>)_
  A list of resource definitions that can be either a request or a transform.
  - **`resource`** _(string)_
    The name of the resource to sync. For Unified APIs, it should be in the format `unified_api_name/resource_name`. For Proxy API, it can just be `resource_name`.
  - **`method`** _(string)_
    The method to call on the resource.
  - **`id`** _(string)_
    The ID of the resource to sync. This is optional and can be used to sync a single resource. It also supports placeholders.
  - **`query`** _(object)_
    The query parameters to pass to the resource method. It supports placeholders for values.
  - **`loop_on`** _(string)_
    When a particular placeholder argument is an array and you want to repeat the request for each element in that array, you can set this parameter. For example, if you accept an argument called `user_ids` which is an array of strings, and you want to fetch each user's details, you can set this parameter to `user_ids` and the request will be repeated for each element in the `user_ids` array.
  - **`depends_on`** _(string)_
    The resource that this resource depends on (parent resource). This is optional and can be used to sync a resource only after another resource has been synced. Each object synced for the parent resource is available as the resources object in placeholders for the child resource, e.g. `{{resources.crm.contacts.id}}` if depends on is `crm/contacts` resource.
  - **`persist`** _(boolean)_
    Whether to persist the resource in the database or not in case of a Daemon sync job run or send as a payload in case of RapidBridge sync job run. The Proxy API resources are by default NOT persisted and this parameter can be set to `true` to persist them. Unified API resources are always persisted.

## Response body

- **`result`** _(object)_
  A map of resource names to fetched records.
- **`errors`** _(object)_
  A map of resource names to encountered errors (if any).

## Code examples

### curl

```bash
curl -X POST 'https://api.truto.one/batch-request' \
  -H 'Authorization: Bearer <your_api_token>' \
  -H 'Content-Type: application/json' \
  -d '{
  "integrated_account_id": "your_integrated_account_id",
  "args": {
    "my_placeholder": 123
  },
  "resources": []
}'
```

### JavaScript

```javascript
const body = {
  "integrated_account_id": "your_integrated_account_id",
  "args": {
    "my_placeholder": 123
  },
  "resources": []
};

const response = await fetch('https://api.truto.one/batch-request', {
  method: 'POST',
  headers: {
    'Authorization': 'Bearer <your_api_token>',
    'Content-Type': 'application/json',
  },
  body: JSON.stringify(body),
});

const data = await response.json();
console.log(data);
```

### Python

```python
import requests

url = "https://api.truto.one/batch-request"
headers = {
    "Authorization": "Bearer <your_api_token>",
    "Content-Type": "application/json",
}
params = {
}
payload = {
    "integrated_account_id": "your_integrated_account_id",
    "args": {
        "my_placeholder": 123
    },
    "resources": []
}

response = requests.post(url, headers=headers, params=params, json=payload)
print(response.json())
```

### Truto TS SDK

```typescript
import Truto from '@truto/truto-ts-sdk';

const truto = new Truto({
  token: '<your_api_token>',
});

const body = {
  "integrated_account_id": "your_integrated_account_id",
  "args": {
    "my_placeholder": 123
  },
  "resources": []
};

const result = await truto.batchRequest.create(body);

console.log(result);
```

### Truto Python SDK

```python
import asyncio
from truto_python_sdk import TrutoApi

truto_api = TrutoApi(token="<your_api_token>")

async def main():
    body = {
        "integrated_account_id": "your_integrated_account_id",
        "args": {
            "my_placeholder": 123
        },
        "resources": []
    }

    result = await truto_api.batch_requests.create(body)
    print(result)

asyncio.run(main())
```
